package concurrency.week08;

public class OnewayBridge {

	protected int numtowest = 0;
	protected int numtoeast = 0;

	protected StringBuffer log = new StringBuffer();

	synchronized void enterToWest() throws InterruptedException {
		while (numtoeast > 0 || numtowest > 3) {
			wait();
		}
		numtowest++;
		log.append("entered to west\n");
	}

	synchronized void exitToWest() {
		numtowest--;
		notifyAll();
		log.append("exited to west\n");
	}

	synchronized void enterToEast() throws InterruptedException {
		while (numtowest > 0 || numtoeast > 3) {
			wait();
		}
		numtoeast++;
		log.append("entered to east\n");
	}

	synchronized void exitToEast() {
		numtoeast--;
		notifyAll();
		log.append("exited to east\n");
	}

	public static void main(String args[]) throws InterruptedException {
		OnewayBridge bridge = new OnewayBridge();

		Thread[] wcars = new Thread[100];
		Thread[] ecars = new Thread[100];
		for (int i = 0; i < 100; i++) {
			wcars[i] = new Thread(new CarToWest(bridge));
			ecars[i] = new Thread(new CarToEast(bridge));
			wcars[i].start();
			ecars[i].start();
		}

		for (int i = 0; i < 100; i++) {
			wcars[i].join();
			ecars[i].join();
		}

		System.out.println(bridge.log);
	}

}
