package concurrency.week08;

public class OnewayBridgeFair extends OnewayBridge{

	private int numwaittowest = 0;
	private int numwaittoeast = 0;
	private boolean westturn = true;

	private StringBuffer log = new StringBuffer();

	@Override
	synchronized void enterToWest() throws InterruptedException {
		numwaittowest++;
		while (numtoeast > 0 || numtowest > 3 || (numwaittoeast > 0 && !westturn)) {
			wait();
		}
		numtowest++;
		log.append("entered to west\n");
	}

	@Override
	synchronized void exitToWest() {
		numtowest--;
		westturn = false;
		notifyAll();
		log.append("exited to west\n");
	}

	@Override
	synchronized void enterToEast() throws InterruptedException {
		numwaittoeast++;
		while (numtowest > 0 || numtoeast > 3 || (numwaittowest > 0 && westturn)) {
			wait();
		}
		numtoeast++;
		log.append("entered to east\n");
	}

	@Override
	synchronized void exitToEast() {
		numtoeast--;
		westturn = true;
		notifyAll();
		log.append("exited to east\n");
	}

	public static void main(String args[]) throws InterruptedException {
		OnewayBridgeFair bridge = new OnewayBridgeFair();

		Thread[] wcars = new Thread[100];
		Thread[] ecars = new Thread[100];
		for (int i = 0; i < 100; i++) {
			wcars[i] = new Thread(new CarToWest(bridge));
			ecars[i] = new Thread(new CarToEast(bridge));
			wcars[i].start();
			ecars[i].start();
		}

		for (int i = 0; i < 100; i++) {
			wcars[i].join();
			ecars[i].join();
		}

		System.out.println(bridge.log);
	}

}

